import * as React from 'react';
import { ValidateMessages, FormInstance, FieldData } from './interface';
interface Forms {
    [name: string]: FormInstance;
}
interface FormChangeInfo {
    changedFields: FieldData[];
    forms: Forms;
}
export interface FormProviderProps {
    validateMessages?: ValidateMessages;
    onFormChange?: (name: string, info: FormChangeInfo) => void;
}
export interface FormContextProps extends FormProviderProps {
    triggerFormChange: (name: string, changedFields: FieldData[]) => void;
    registerForm: (name: string, form: FormInstance) => () => void;
}
declare const FormContext: React.Context<FormContextProps>;
declare const FormProvider: React.FunctionComponent<FormProviderProps>;
export { FormProvider };
export default FormContext;
